# Demo script for last page of presentation.

if {![info exists top]} { pack [frame [set top .f]] -fill both -expand y }

proc Flasher {lb llst buts idx} {
   incr idx
   set time 1000
   set ll [llength $buts]
   if {![winfo exists $lb]} return
   if {$idx < ([llength $llst]-1)} {
      $lb insert end [lindex $llst [expr {$idx+1}]]
      $lb selection clear 0 end
      $lb selection set end
      $lb activate end
      $lb see end
      if {$idx==([llength $llst]-2)} {
         $lb itemconf end -foreground darkred
      }
      update idletasks
   } else {
      $lb conf -height [$lb index end]
   }
   #set old [$lb index @0,0]
   #$lb yview scroll 1 unit
   #if {$old == [$lb index @0,0]} {
   #   $lb see 0
   #}
   if {$idx<$ll} {
     set b [lindex $buts $idx]
     $b flash; $b flash; $b flash
   } elseif {$idx<=(3*$ll)} {
     set state [expr {($idx-$ll)%2?"active":"normal"}]
     foreach b $buts {
        $b conf -state $state
     }
     set time 500
   } else {
      $lb see 0
      foreach b $buts {
        $b conf -state active
      }
      return
   }
   after $time [list [namespace current]::Flasher $lb $llst $buts $idx]
}


proc FillBeach {top} {
    set img Beach
    set imga Beach2
    set img2 Flame
    catch {
        #NOWARN: 3
        font create Slider-Beach -family Times -size 18
        font create Slider-List -family Times -size 10
        font create Slider-Button -family Times -size 24 -weight bold
        image create photo Beach -file ~/w/Download/beach.jpg
        image create photo Beach2 -file ~/w/Download/beach.jpg -gamma 2
        image create photo $img2
        winop image gradient $img2 Orange Yellow -width 200 -height 80
    }

    $top conf -bd 1 -bg black
    pack [frame $top.f -tiletop 1] -fill both -expand y
    set top $top.f

    pack [canvas $top.c -bd 0 -highlightthickness 0 -tile $img -width [image width $img] -height [image height $img]] -fill both -expand y

    place [label $top.c.l -tile $img -font Slider-Button -text "Wize lives here:" -foreground Blue ] -relx 0.5 -rely 0.022 -anchor c
    place [label $top.c.l2 -tile $img -font Slider-Button -text "http://pdqi.com" ] -relx 0.5 -rely 0.09 -anchor c
    place [frame $top.c.ff -tile $img] -relx 0.5 -rely 0.4 -anchor c
    pack [label $top.c.ff.l -tile $img -font Slider-Beach -text "Acknowledgments"] -fill x
    pack [listbox [set lb $top.c.ff.lb] -tile $imga -selectbackground Gold -font Slider-List -height 4 -width 60] -fill both -expand y
  Listbox conf $lb -highlightthickness 0 -bd 0
    set n 0
    set lst {
        "George A. Howlett : creator of BLT"
        "Richard Hipp : Tobe, Canvas3d, & Sqlite"
        "Jan Nijtmans : Img"
        "Jeff Hobbs: TkTable/Vu"
        "Tim Baker : TreeCtrl"
        "Kare Sjolander : Snack"
        "Rildo Pragana : shaped toplevels"
        "Vince Darley : TclVfs"
        "Michael Schwartz : signal"
        "Activestate : various & sundry"
        "and the community at wiki.tcl.tk"
    }
    $lb insert end [lindex $lst 0]
    $lb selection set end
    focus $lb
    place [frame $top.c.f -tile $img] -x 0 -relwidth 1 -rely .6
    set buts {}
    set cmd "tk_messageBox -message {Thanks for watching}"
    foreach str { "17th Annual" "Tcl/Tk Conference" "2010" "Chicago"} {
        pack [blt::tile::button [set bb $top.c.f.b[incr n]] -shape rounded -activetile $img2 -innertile $img -tile $img -text $str] -padx 10 -side left
        $bb conf -highlightthick 0 -foreground DarkRed -font Slider-Button -command $cmd
        lappend buts $bb
    }
    set wp [winfo parent [winfo parent $top]]
    if {[winfo class $wp] == "Text"} {
        $wp tag conf myhdr -foreground Black
        eval $wp tag add myhdr [$wp tag ranges h1]
    }

    after 1000 [list [namespace current]::Flasher $lb $lst $buts -1]
}

FillBeach $top
