
/* C extension module for Tcl auto generated by CAPI (see http://pdqi.com) */
#include <tcl.h>   

struct ModData;

/* Per-cmd data */
typedef struct {
    CONST char *cmd;
    CONST char *sig;
    Tcl_ObjCmdProc *capi;
    Tcl_Command ctok;
    int n;
    int calls;
    int valid;
    struct ModData *modPtr;
    
} CmdData;

/* Data for the module, per-interp. */
typedef struct ModData {
    int version;
    int calls;
    int valid;
    CmdData *cmdPtr;
    
} ModData;
    



static void Cmd_Delete (ClientData clientData) {
	CmdData *cmdPtr = (CmdData*)clientData;
	ModData *modPtr = cmdPtr->modPtr;

}
/* proc add {i j} #TYPES: . Double Double */
static int capi_add(
        ClientData clientData,/* State. */
        Tcl_Interp *interp,   /* Current interpreter. */
        int objc,             /* Number of arguments. */
        Tcl_Obj *CONST objv[] /* Argument objects. */
    )
{
    int len, result = TCL_OK;
    CmdData *cmdPtr = (CmdData*)clientData;
    ModData *modPtr = cmdPtr->modPtr;
    double arg_i = 0;
    int opt_i = 1;
    double arg_j = 0;
    int opt_j = 2;
    cmdPtr->calls++; modPtr->calls++;
    if (objc<3) { Tcl_WrongNumArgs(interp, 1, objv, "i j"); return TCL_ERROR; }
    if (objc>3) { Tcl_WrongNumArgs(interp, 1, objv, "i j"); return TCL_ERROR; }

                    if (cmdPtr) {
                        if (Tcl_WarnCheckCall(interp, cmdPtr->ctok, objc, objv) != TCL_OK) {
                            return TCL_ERROR;
                        }
                    }
                
    if (objc<=1) {  return TCL_ERROR; } else {        if (Tcl_GetDoubleFromObj(interp, objv[1], &arg_i) != TCL_OK) { return TCL_ERROR; }
    }
    if (objc<=2) {  return TCL_ERROR; } else {        if (Tcl_GetDoubleFromObj(interp, objv[2], &arg_j) != TCL_OK) { return TCL_ERROR; }
    }
    /* Begin code */

    Tcl_SetObjResult(interp, Tcl_NewDoubleObj(arg_i + arg_j));
      /* End code */
done:
    if (result == TCL_OK) { cmdPtr->valid++; modPtr->valid++;}
    return result;
}


/* proc sub {i j} #TYPES: . Double Double */
static int capi_sub(
        ClientData clientData,/* State. */
        Tcl_Interp *interp,   /* Current interpreter. */
        int objc,             /* Number of arguments. */
        Tcl_Obj *CONST objv[] /* Argument objects. */
    )
{
    int len, result = TCL_OK;
    CmdData *cmdPtr = (CmdData*)clientData;
    ModData *modPtr = cmdPtr->modPtr;
    double arg_i = 0;
    int opt_i = 1;
    double arg_j = 0;
    int opt_j = 2;
    cmdPtr->calls++; modPtr->calls++;
    if (objc<3) { Tcl_WrongNumArgs(interp, 1, objv, "i j"); return TCL_ERROR; }
    if (objc>3) { Tcl_WrongNumArgs(interp, 1, objv, "i j"); return TCL_ERROR; }

                    if (cmdPtr) {
                        if (Tcl_WarnCheckCall(interp, cmdPtr->ctok, objc, objv) != TCL_OK) {
                            return TCL_ERROR;
                        }
                    }
                
    if (objc<=1) {  return TCL_ERROR; } else {        if (Tcl_GetDoubleFromObj(interp, objv[1], &arg_i) != TCL_OK) { return TCL_ERROR; }
    }
    if (objc<=2) {  return TCL_ERROR; } else {        if (Tcl_GetDoubleFromObj(interp, objv[2], &arg_j) != TCL_OK) { return TCL_ERROR; }
    }
    /* Begin code */

    Tcl_SetObjResult(interp, Tcl_NewDoubleObj(arg_i - arg_j));
      /* End code */
done:
    if (result == TCL_OK) { cmdPtr->valid++; modPtr->valid++;}
    return result;
}


int Appmath_Init (Tcl_Interp *interp ) {
    int len, result = TCL_OK; Tcl_Obj *resPtr;

    CONST char *cmds[] = {
        "::app::math::add",
        "::app::math::sub", 0 };
   Tcl_ObjCmdProc *capi[] = {
       capi_add,
       capi_sub, 0 };
   ModData *modPtr = NULL;
   CmdData *ents = NULL;
    int nn = -1;

#ifdef USE_TCL_STUBS
	        if (Tcl_InitStubs(interp, "8.5", 0) == NULL)
#else
                if (Tcl_PkgRequire(interp, "Tcl", "8.5", 0) == NULL)
#endif
                {
                    return TCL_ERROR;
                }
#ifdef TK_VERSION    
                if (Tcl_PkgRequire(interp, "Tk", "8.5", 0) == NULL) {
                    return TCL_ERROR;
                }
#endif
                   modPtr = (ModData*)ckalloc(sizeof(ModData));
   ents = (CmdData*)ckalloc(sizeof(CmdData) * sizeof(cmds)/sizeof(char*));
    memset(modPtr, 0, sizeof(ModData));
    memset(modPtr, 0, sizeof(sizeof(CmdData) * sizeof(cmds)/sizeof(char*)));
    modPtr->version = 1;
    modPtr->cmdPtr = ents;
    while (cmds[++nn]) {

      CmdData *cc = ents + nn;
      cc->n = nn;
      cc->modPtr = modPtr;
      cc->cmd = cmds[nn];
      cc->capi = capi[nn];
      cc->ctok = Tcl_CreateObjCommand(interp, cmds[nn], capi[nn], cc, Cmd_Delete);
    }
    ents[nn].cmd = NULL;

    {
    char *sigs[] = {
        "::extern ::app::math::add {i j} {. Double Double} I {}",
        "::extern ::app::math::sub {i j} {. Double Double} I {}", 0 };
    int nn = -1;
    while (sigs[++nn]) {
        Tcl_Eval(interp, sigs[nn]);
        ents[nn].sig = sigs[nn];
    }
 }
    result = Tcl_GlobalEval(interp, "namespace eval ::app::math { namespace export {[a-z]*} }");
    if (result != TCL_OK) goto error;
    result = Tcl_GlobalEval(interp, "::namespace eval ::app::math { ::namespace ensemble create }; if {[::namespace parent] != {::}} { ::namespace eval ::app { ::namespace export math } }; set ::app::math::pd(version) 0.0; set ::app::math::pd(libname) Appmath; set ::app::math::pd(pkgname) {}");
    if (result != TCL_OK) goto error;

	if (result != TCL_OK) goto error;
    Tcl_SetAssocData(interp, "capi/Appmath", NULL, modPtr );
    resPtr = Tcl_NewStringObj("::app::math Appmath 0.0 {-wize True -safe True -capi 1 -modtype 1 -delns False}", -1);
    Tcl_SetVar2(interp, "::app::math", "load", Tcl_GetString(resPtr), 0);
    Tcl_SetObjResult(interp, resPtr);
    return result;

    error:
	if (modPtr) ckfree((char*)modPtr);
    	if (ents) ckfree((char*)ents);
    return TCL_ERROR;
}

int Appmath_Unload (Tcl_Interp *interp ) {
    int nn; ModData *modPtr = (ModData*)Tcl_GetAssocData(interp, "capi/Appmath", NULL );
    if (modPtr == NULL) { return TCL_OK; }
    
    nn = -1; while (modPtr->cmdPtr[++nn].cmd) Tcl_DeleteCommandFromToken(interp, modPtr->cmdPtr[nn].ctok);
    Tcl_DeleteAssocData(interp, "capi/Appmath");
    ckfree((char*)modPtr->cmdPtr);
    ckfree((char*)modPtr);
    return TCL_OK; 
}

int Appmath_SafeInit (Tcl_Interp *interp ) {
	return Appmath_Init (interp ); 
}

int Appmath_SafeUnload (Tcl_Interp *interp, int code ) {
	return Appmath_Unload (interp ); 
}

